Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/physiq.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/physiq.F	(revision 3)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/physiq.F	(revision 300)
@@ -1,10 +1,15 @@
+c
+c $Header$
+c
       SUBROUTINE physiq (nlon,nlev,nqmax  ,
      .            debut,lafin,rjourvrai,rjour_ecri,gmtime,pdtphys,
      .            paprs,pplay,pphi,pphis,paire,presnivs,clesphy0,
      .            u,v,t,qx,
-     .            d_u_dyn, d_v_dyn,  d_t_dyn, d_qx_dyn,
-     .            omega,
+     .            omega, cufi, cvfi,
      .            d_u, d_v, d_t, d_qx, d_ps)
       USE ioipsl
+      USE histcom
+      USE writephys
+
       IMPLICIT none
 c======================================================================
@@ -40,9 +45,9 @@
 c t-------input-R-temperature (K)
 c qx------input-R-humidite specifique (kg/kg) et d'autres traceurs
-c d_u_dyn-input-R-tendance dynamique pour "u" (m/s/s)
-c d_v_dyn-input-R-tendance dynamique pour "v" (m/s/s)
 c d_t_dyn-input-R-tendance dynamique pour "t" (K/s)
-c d_qx_dyn-input-R-tendance dynamique pour "qx" (kg/kg/s)
+c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
 c omega---input-R-vitesse verticale en Pa/s
+c cufi----input-R-resolution des mailles en x (m)
+c cvfi----input-R-resolution des mailles en y (m)
 c
 c d_u-----output-R-tendance physique de "u" (m/s/s)
@@ -53,4 +58,6 @@
 c======================================================================
 #include "dimensions.h"
+      integer jjmp1
+      parameter (jjmp1=jjm+1-1/jjm)
 #include "dimphy.h"
 #include "regdim.h"
@@ -59,31 +66,26 @@
 #include "clesphys.h"
 #include "control.h"
+#include "temps.h"
 c======================================================================
       LOGICAL check ! Verifier la conservation du modele en eau
       PARAMETER (check=.FALSE.)
+      LOGICAL ok_stratus ! Ajouter artificiellement les stratus
+      PARAMETER (ok_stratus=.FALSE.)
 c======================================================================
 c Parametres lies au coupleur OASIS:
 #include "oasis.h"
-      INTEGER npas, nexca, itimestep
+      INTEGER,SAVE :: npas, nexca
       logical rnpb
       parameter(rnpb=.true.)
-      PARAMETER (npas=1440)
-      PARAMETER (nexca=48)
-      PARAMETER (itimestep=1800)
-      EXTERNAL intocpl, inicma
-c======================================================================
-c ok_ocean indique l'utilisation du modele oceanique "slab ocean",
-c il faut bien sur s'assurer que le bilan energetique de reference
-c a la surface de l'ocean est bien present dans le fichier des
-c conditions aux limites, ainsi que l'indicateur du sol ne contient
-c pas de glace oceanique (pas de valeur 3).
-c
-      LOGICAL ok_ocean
-      PARAMETER (ok_ocean=.FALSE.)
-      REAL cyang  ! capacite thermique de l'ocean superficiel
-      PARAMETER (cyang=30.0 * 4.228e+06)
-      REAL cbing  ! capacite thermique de la glace oceanique
-      PARAMETER (cbing=1.0 * 4.228e+06)
-      REAL cthermiq
+c      PARAMETER (npas=1440)
+c      PARAMETER (nexca=48)
+      EXTERNAL fromcpl, intocpl, inicma
+c      ocean = type de modele ocean a utiliser: force, slab, couple
+      character*6 ocean
+      SAVE ocean
+
+c      parameter (ocean = 'force ')
+c     parameter (ocean = 'couple')
+      logical ok_ocean
 c======================================================================
 c Clef controlant l'activation du cycle diurne:
@@ -94,6 +96,8 @@
 ccc      LOGICAL soil_model
 ccc      PARAMETER (soil_model=.FALSE.)
-      REAL soilcap(klon,nbsrf), soilflux(klon,nbsrf)
-      SAVE soilcap, soilflux
+      logical ok_veget
+      save ok_veget
+c     parameter (ok_veget = .true.)
+c      parameter (ok_veget = .false.)
 c======================================================================
 c Dans les versions precedentes, l'eau liquide nuageuse utilisee dans
@@ -112,11 +116,14 @@
 c======================================================================
       LOGICAL ok_journe ! sortir le fichier journalier
-      PARAMETER (ok_journe=.FALSE.)
+      save ok_journe
+c      PARAMETER (ok_journe=.true.)
 c
       LOGICAL ok_mensuel ! sortir le fichier mensuel
-      PARAMETER (ok_mensuel=.TRUE.)
+      save ok_mensuel
+c      PARAMETER (ok_mensuel=.true.)
 c
       LOGICAL ok_instan ! sortir le fichier instantane
-      PARAMETER (ok_instan=.FALSE.)
+      save ok_instan
+c      PARAMETER (ok_instan=.true.)
 c
       LOGICAL ok_region ! sortir le fichier regional
@@ -128,9 +135,11 @@
       INTEGER iliq          ! indice de traceurs pour eau liquide
       PARAMETER (iliq=2)
-c
+
       INTEGER nvm           ! nombre de vegetations
       PARAMETER (nvm=8)
       REAL veget(klon,nvm)  ! couverture vegetale
       SAVE veget
+
+c
 c
 c Variables argument:
@@ -150,4 +159,6 @@
       REAL presnivs(klev)
       REAL znivsig(klev)
+      REAL zsurf(nbsrf)
+      real cufi(klon), cvfi(klon)
 
       REAL u(klon,klev)
@@ -156,8 +167,11 @@
       REAL qx(klon,klev,nqmax)
 
-      REAL d_u_dyn(klon,klev)
-      REAL d_v_dyn(klon,klev)
+      REAL t_ancien(klon,klev), q_ancien(klon,klev)
+      SAVE t_ancien, q_ancien
+      LOGICAL ancien_ok
+      SAVE ancien_ok
+
       REAL d_t_dyn(klon,klev)
-      REAL d_qx_dyn(klon,klev,2)
+      REAL d_q_dyn(klon,klev)
 
       REAL omega(klon,klev)
@@ -214,4 +228,9 @@
       SAVE ftsoil                 ! temperature dans le sol
 c
+      REAL fevap(klon,nbsrf)
+      SAVE fevap                 ! evaporation
+      REAL fluxlat(klon,nbsrf)
+      SAVE fluxlat
+c
       REAL deltat(klon)
       SAVE deltat                 ! ecart avec la SST de reference
@@ -223,6 +242,10 @@
       SAVE fsnow                  ! epaisseur neigeuse
 c
-      REAL rugmer(klon)
-      SAVE rugmer                 ! longeur de rugosite sur mer (m)
+      REAL falbe(klon,nbsrf)
+      SAVE falbe                  ! albedo par type de surface
+      REAL falblw(klon,nbsrf)
+      SAVE falblw                 ! albedo par type de surface
+
+c
 c
 c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
@@ -257,11 +280,40 @@
       SAVE zuthe
       SAVE zvthe
-      INTEGER igwd,igwdim,idx(klon),itest(klon)
-c
-      REAL agesno(klon)
+      INTEGER igwd,idx(klon),itest(klon)
+c
+      REAL agesno(klon,nbsrf)
       SAVE agesno                 ! age de la neige
 c
       REAL alb_neig(klon)
       SAVE alb_neig               ! albedo de la neige
+cKE43
+c Variables liees a la convection de K. Emanuel (sb):
+c
+      REAL ema_workcbmf(klon)   ! cloud base mass flux
+      SAVE ema_workcbmf
+
+      REAL ema_cbmf(klon)       ! cloud base mass flux
+      SAVE ema_cbmf
+
+      REAL ema_pcb(klon)        ! cloud base pressure
+      SAVE ema_pcb
+
+      REAL ema_pct(klon)        ! cloud top pressure
+      SAVE ema_pct
+
+      REAL bas, top             ! cloud base and top levels
+      SAVE bas
+      SAVE top
+
+      REAL Ma(klon,klev)        ! undilute upward mass flux
+      SAVE Ma
+      REAL ema_work1(klon, klev), ema_work2(klon, klev)
+      SAVE ema_work1, ema_work2
+      REAL wdn(klon), tdn(klon), qdn(klon)
+c Variables locales pour la couche limite (al1):
+c
+cAl1      REAL pblh(klon)           ! Hauteur de couche limite
+cAl1      SAVE pblh
+c34EK
 c
 c Variables locales:
@@ -276,5 +328,6 @@
       REAL yv1(klon)            ! vents dans la premiere couche V
       LOGICAL offline           ! Controle du stockage ds "physique"
-      PARAMETER (offline=.TRUE.)
+      PARAMETER (offline=.false.)
+      INTEGER physid
       REAL pfrac_impa(klon,klev)! Produits des coefs lessivage impaction
       save pfrac_impa
@@ -288,9 +341,11 @@
       REAL rain_fall(klon) ! pluie
       REAL snow_fall(klon) ! neige
+      save snow_fall, rain_fall
       REAL evap(klon), devap(klon) ! evaporation et sa derivee
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
+      REAL dlw(klon)    ! derivee infra rouge
       REAL bils(klon) ! bilan de chaleur au sol
       REAL fder(klon) ! Derive de flux (sensible et latente) 
-      REAL ruis(klon) ! ruissellement
+      save fder
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
       REAL vq(klon) ! integr. verticale du transport meri. de l'eau
@@ -299,4 +354,5 @@
 c
       REAL frugs(klon,nbsrf) ! longueur de rugosite
+      save frugs
       REAL zxrugs(klon) ! longueur de rugosite
 c
@@ -311,16 +367,13 @@
       REAL pctsrf(klon,nbsrf)
       SAVE pctsrf                 ! sous-fraction du sol
-      REAL lmt_sst(klon)
-      SAVE lmt_sst                ! temperature de la surface ocean
-      REAL lmt_bils(klon)
-      SAVE lmt_bils               ! bilan de chaleur au sol
-      REAL lmt_alb(klon)
-      SAVE lmt_alb                ! temperature de la surface ocean
-      REAL lmt_rug(klon)
-      SAVE lmt_rug                ! longueur de rugosite
-      REAL alb_eau(klon)
-      SAVE alb_eau                ! albedo sur l'ocean
       REAL albsol(klon)
       SAVE albsol                 ! albedo du sol total
+      REAL albsollw(klon)
+      SAVE albsollw                 ! albedo du sol total
+      REAL albsol1(klon)
+      SAVE albsol1                 ! albedo du sol total
+      REAL albsollw1(klon)
+      SAVE albsollw1                 ! albedo du sol total
+
       REAL wo(klon,klev)
       SAVE wo                     ! ozone
@@ -336,5 +389,6 @@
       EXTERNAL condsurf  ! lire les conditions aux limites
       EXTERNAL conlmd    ! convection (schema LMD)
-      EXTERNAL diagcld   ! nuages diagnostiques
+cKE43
+      EXTERNAL conema  ! convect4.3
       EXTERNAL fisrtilp  ! schema de condensation a grande echelle (pluie)
 cAA 
@@ -344,5 +398,4 @@
 cAA
       EXTERNAL hgardfou  ! verifier les temperatures
-      EXTERNAL hydrol    ! hydrologie du sol
       EXTERNAL nuage     ! calculer les proprietes radiatives
       EXTERNAL o3cm      ! initialiser l'ozone
@@ -368,9 +421,15 @@
       REAL cldemi(klon,klev)  ! emissivite infrarouge
 c
-      REAL fluxq(klon,klev)   ! flux turbulent d'humidite
-      REAL fluxt(klon,klev)   ! flux turbulent de chaleur
-      REAL fluxu(klon,klev)   ! flux turbulent de vitesse u
-      REAL fluxv(klon,klev)   ! flux turbulent de vitesse v
-c
+C§§§ PB 
+      REAL fluxq(klon,klev, nbsrf)   ! flux turbulent d'humidite
+      REAL fluxt(klon,klev, nbsrf)   ! flux turbulent de chaleur
+      REAL fluxu(klon,klev, nbsrf)   ! flux turbulent de vitesse u
+      REAL fluxv(klon,klev, nbsrf)   ! flux turbulent de vitesse v
+c
+      REAL zxfluxt(klon, klev)
+      REAL zxfluxq(klon, klev)
+      REAL zxfluxu(klon, klev)
+      REAL zxfluxv(klon, klev)
+C§§§
       REAL heat(klon,klev)    ! chauffage solaire
       REAL heat0(klon,klev)   ! chauffage solaire ciel clair
@@ -378,9 +437,10 @@
       REAL cool0(klon,klev)   ! refroidissement infrarouge ciel clair
       REAL topsw(klon), toplw(klon), solsw(klon), sollw(klon)
+      real sollwdown(klon)    ! downward LW flux at surface
       REAL topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon)
       REAL albpla(klon)
 c Le rayonnement n'est pas calcule tous les pas, il faut donc
 c                      sauvegarder les sorties du rayonnement
-      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw
+      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
       SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
       INTEGER itaprad
@@ -393,5 +453,4 @@
       REAL cldt(klon),cldq(klon) !nuage total, eau liquide integree
 c
-      REAL zx_alb_lic, zx_alb_oce, zx_alb_ter, zx_alb_sic
       REAL zxtsol(klon), zxqsol(klon), zxsnow(klon)
 c
@@ -402,14 +461,44 @@
       CHARACTER*2 iqn
 c
+      REAL qcheck
+      REAL z_avant(klon), z_apres(klon), z_factor(klon)
+      LOGICAL zx_ajustq
+c
       REAL za, zb
-      REAL zx_t, zx_qs, zdelta, zcor, zfra, zlvdcp, zlsdcp
-      INTEGER i, k, iq, ig, j, nsrf, ll
+      REAL zx_t, zx_qs, zdelta, zcor, zlvdcp, zlsdcp
+      INTEGER i, k, iq, nsrf, ll
       REAL t_coup
       PARAMETER (t_coup=234.0)
 c
       REAL zphi(klon,klev)
-      REAL zx_tmp_x(iim), zx_tmp_y(jjm+1)
-      REAL zx_relief(iim,jjm+1)
-      REAL zx_aire(iim,jjm+1)
+      REAL zx_tmp_x(iim), zx_tmp_yjjmp1
+      REAL zx_relief(iim,jjmp1)
+      REAL zx_aire(iim,jjmp1)
+cKE43
+c Variables locales pour la convection de K. Emanuel (sb):
+c
+      REAL upwd(klon,klev)      ! saturated updraft mass flux
+      REAL dnwd(klon,klev)      ! saturated downdraft mass flux
+      REAL dnwd0(klon,klev)     ! unsaturated downdraft mass flux
+      REAL tvp(klon,klev)       ! virtual temp of lifted parcel
+      REAL cape(klon)           ! CAPE
+      SAVE cape
+      REAL pbase(klon)          ! cloud base pressure
+      SAVE pbase
+      REAL bbase(klon)          ! cloud base buoyancy
+      SAVE bbase
+      REAL rflag(klon)          ! flag fonctionnement de convect
+      INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
+c -- convect43:
+      INTEGER ntra              ! nb traceurs pour convect4.3
+      REAL pori_con(klon)    ! pressure at the origin level of lifted parcel
+      REAL plcl_con(klon),dtma_con(klon),dtlcl_con(klon)
+      REAL dtvpdt1(klon,klev), dtvpdq1(klon,klev)
+      REAL dplcldt(klon), dplcldr(klon)
+c?     .     condm_con(klon,klev),conda_con(klon,klev),
+c?     .     mr_con(klon,klev),ep_con(klon,klev)
+c?     .    ,sadiab(klon,klev),wadiab(klon,klev)
+c --
+c34EK
 c
 c Variables du changement
@@ -423,5 +512,5 @@
       REAL d_u_con(klon,klev),d_v_con(klon,klev)
       REAL d_t_lsc(klon,klev),d_q_lsc(klon,klev),d_ql_lsc(klon,klev)
-c      REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
       REAL d_t_eva(klon,klev),d_q_eva(klon,klev)
       REAL rneb(klon,klev)
@@ -432,4 +521,5 @@
       INTEGER kcbot(klon), kctop(klon), kdtop(klon)
       REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)
+      REAL prfl(klon,klev+1), psfl(klon,klev+1)
 c
       INTEGER ibas_con(klon), itop_con(klon)
@@ -445,4 +535,8 @@
       REAL d_u_lif(klon,klev), d_v_lif(klon,klev)
       REAL d_t_lif(klon,klev)
+
+      REAL ratqs(klon,klev)
+      real zpt_conv(klon,klev)
+
 c
 c Variables liees a l'ecriture de la bande histoire physique
@@ -460,30 +554,4 @@
       SAVE ecrit_reg   ! frequence d'ecriture
 c
-      REAL oas_sols(klon), z_sols(iim,jjm+1)
-      SAVE oas_sols
-      REAL oas_nsol(klon), z_nsol(iim,jjm+1)
-      SAVE oas_nsol
-      REAL oas_rain(klon), z_rain(iim,jjm+1)
-      SAVE oas_rain
-      REAL oas_snow(klon), z_snow(iim,jjm+1)
-      SAVE oas_snow
-      REAL oas_evap(klon), z_evap(iim,jjm+1)
-      SAVE oas_evap
-      REAL oas_ruis(klon), z_ruis(iim,jjm+1)
-      SAVE oas_ruis
-      REAL oas_tsol(klon), z_tsol(iim,jjm+1)
-      SAVE oas_tsol
-      REAL oas_fder(klon), z_fder(iim,jjm+1)
-      SAVE oas_fder
-      REAL oas_albe(klon), z_albe(iim,jjm+1)
-      SAVE oas_albe
-      REAL oas_taux(klon), z_taux(iim,jjm+1)
-      SAVE oas_taux
-      REAL oas_tauy(klon), z_tauy(iim,jjm+1)
-      SAVE oas_tauy
-      REAL oas_ruisoce(klon), z_ruisoce(iim,jjm+1)
-      SAVE oas_ruisoce
-      REAL oas_ruisriv(klon), z_ruisriv(iim,jjm+1)
-      SAVE oas_ruisriv
 c
 c
@@ -496,8 +564,6 @@
       REAL tr_seri(klon,klev,nbtr)
       REAL d_tr(klon,klev,nbtr)
-      REAL source_tr(klon,nbtr)
 
       REAL zx_rh(klon,klev)
-      REAL dtimeday,dtimecri,dtimexp9,fecri_pas,fecri86400,fecritday
 
       INTEGER        length
@@ -505,8 +571,8 @@
       REAL tabcntr0( length       )
 c
-      INTEGER ndex(1)
+      INTEGER ndex2d(iim*jjmp1),ndex3d(iim*jjmp1*klev)
       REAL zx_tmp_fi2d(klon)
-      REAL zx_tmp_2d(iim,jjm+1), zx_tmp_3d(iim,jjm+1,klev)
-      REAL zx_lon(iim,jjm+1), zx_lat(iim,jjm+1)
+      REAL zx_tmp_2d(iim,jjmp1), zx_tmp_3d(iim,jjmp1,klev)
+      REAL zx_lon(iim,jjmp1), zx_lat(iim,jjmp1)
 c
       INTEGER nid_day, nid_mth, nid_ins
@@ -514,10 +580,23 @@
 c
       INTEGER nhori, nvert
-      REAL zsto, zout, zjulian
+      REAL zsto, zout
+      real zjulian
+      save zjulian
 
       character*20 modname
       character*80 abort_message
       logical ok_sync
-
+      real date0
+
+C essai writephys
+      integer fid_day, fid_mth, fid_ins
+      parameter (fid_ins = 1, fid_day = 2, fid_mth = 3) 
+      integer prof2d_on, prof3d_on, prof2d_av, prof3d_av
+      parameter (prof2d_on = 1, prof3d_on = 2,
+     .           prof2d_av = 3, prof3d_av = 4)
+      character*30 nom_fichier
+      character*10 varname
+      character*40 vartitle
+      character*20 varunits
 c
 c Declaration des constantes et des fonctions thermodynamiques
@@ -536,4 +615,6 @@
          CALL suphec ! initialiser constantes et parametres phys.
       ENDIF
+
+
 c======================================================================
       xjour = rjourvrai
@@ -543,21 +624,11 @@
 c
        IF (debut) THEN
-c
- 
-         IF (ok_oasis) THEN
-            PRINT*, "Attentions! les parametres suivants sont fixes:"
-            PRINT *,'***********************************************'
-            PRINT*, "npas, nexca, itimestep=", npas, nexca, itimestep
-            PRINT*, "Changer-les manuellement s il le faut"
-            PRINT *,'***********************************************'
-            CALL inicma( npas, nexca, itimestep)
-         ENDIF
-c
-         IF (ok_ocean) THEN
-            PRINT*, '************************'
-            PRINT*, 'SLAB OCEAN est active, prenez precautions !'
-            PRINT*, '************************'
-         ENDIF
-c
+
+c
+c appel a la lecture du run.def physique
+c
+         call conf_phys(ocean, ok_veget, ok_journe, ok_mensuel,
+     .                  ok_instan)
+
          DO k = 2, nvm          ! pas de vegetation
             DO i = 1, klon
@@ -570,14 +641,18 @@
          PRINT*, 'Pas de vegetation; desert partout'
 c
+c
 c Initialiser les compteurs:
 c
 
+         frugs = 0.
          itap    = 0
          itaprad = 0
 c
          CALL phyetat0 ("startphy.nc",dtime,co2_ppm,solaire,
-     .         rlat,rlon,ftsol,ftsoil,deltat,fqsol,fsnow,
-     .        radsol,rugmer,agesno,clesphy0,
-     .       zmea,zstd,zsig,zgam,zthe,zpic,zval,rugoro,tabcntr0 )
+     .       rlat,rlon,pctsrf, ftsol,ftsoil,deltat,fqsol,fsnow,
+     .       falbe, fevap, rain_fall,snow_fall,solsw, sollwdown,
+     .       dlw,radsol,frugs,agesno,clesphy0,
+     .       zmea,zstd,zsig,zgam,zthe,zpic,zval,rugoro,tabcntr0,
+     .       t_ancien, q_ancien, ancien_ok )
 
 c
@@ -612,4 +687,21 @@
          PRINT*, "Clef pour la convection, iflag_con=", iflag_con
 c
+cKE43
+c Initialisation pour la convection de K.E. (sb):
+         IF (iflag_con.EQ.4) THEN
+
+         PRINT*, "*** Convection de Kerry Emanuel 4.3  "
+         PRINT*, "On va utiliser le melange convectif des traceurs qui"
+         PRINT*, "est calcule dans convect4.3"
+         PRINT*, " !!! penser aux logical flags de phytrac"
+
+          DO i = 1, klon
+           ema_cbmf(i) = 0.
+           ema_pcb(i)  = 0.
+           ema_pct(i)  = 0.
+           ema_workcbmf(i) = 0.
+          ENDDO
+         ENDIF
+c34EK
          IF (ok_orodr) THEN
          DO i=1,klon
@@ -627,11 +719,4 @@
          ENDIF
 c
-         IF (soil_model) THEN
-            DO nsrf = 1, nbsrf
-            CALL soil(dtime, nsrf, fsnow(1,nsrf),
-     .                ftsol(1,nsrf), ftsoil(1,1,nsrf),
-     .                soilcap(1,nsrf), soilflux(1,nsrf))
-            ENDDO
-         ENDIF
 c
          lmt_pas = NINT(86400./dtime * 1.0)   ! tous les jours
@@ -647,5 +732,7 @@
          ENDIF
 ccc         ecrit_ins = NINT(86400./dtime *0.5)  ! 2 fois par jour
-         ecrit_ins = NINT(86400./dtime *0.25)  ! tous les jours
+ccc         ecrit_ins = NINT(86400./dtime *0.25)  ! 4 fois par jour
+         ecrit_ins = NINT(86400./dtime/48.)  ! a chaque pas de temps
+         ecrit_ins = NINT(86400./dtime/12.)  ! toutes les deux heures
          IF (ok_instan) THEN
          PRINT*, 'La frequence de sortie instant. est de ', ecrit_ins
@@ -655,38 +742,69 @@
          PRINT*, 'La frequence de sortie region est de ', ecrit_reg
          ENDIF
-c
+
+c
+c Initialiser le couplage si necessaire
+c
+      npas = 0
+      nexca = 0
+      if (ocean == 'couple') then
+        npas = itaufin/ iphysiq
+        nexca = 86400 / dtime
+        write(*,*)' ##### Ocean couple #####'
+        write(*,*)' Valeurs des pas de temps'
+        write(*,*)' npas = ', npas
+        write(*,*)' nexca = ', nexca
+      endif        
+c
+c
+c Gestion calendrier
+
+         CALL ymds2ju(anne_ini, 1, 1, 0.0, zjulian)
+         zjulian = zjulian + day_ini
+
 c
       IF (ok_journe) THEN
 c
-C         CALL ymds2ju(1900, 1, 1, 0.0, zjulian)
-         CALL ymds2ju(anneeref, 1, 1, 0.0, zjulian)
-         zjulian = zjulian + dayref
-c
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,zx_lon)
+         CALL ymds2ju(anne_ini, 1, 1, 0.0, zjulian)
+         zjulian = zjulian + day_ini
+c
+         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlon,zx_lon)
          DO i = 1, iim
             zx_lon(i,1) = rlon(i+1)
-            zx_lon(i,jjm+1) = rlon(i+1)
+            zx_lon(i,jjmp1) = rlon(i+1)
          ENDDO
          DO ll=1,klev
             znivsig(ll)=float(ll)
          ENDDO
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,zx_lat)
-         CALL histbeg("histday", iim,zx_lon, jjm+1,zx_lat,
-     .                 1,iim,1,jjm+1, 0, zjulian, dtime, 
+         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
+         CALL histbeg("histday", iim,zx_lon, jjmp1,zx_lat,
+     .                 1,iim,1,jjmp1, 0, zjulian, dtime, 
      .                 nhori, nid_day)
-c         CALL histvert(nid_day, "presnivs", "Vertical levels", "mb",
-c     .                 klev, presnivs, nvert)
-         call histvert(nid_day, 'sig_s', 'Niveaux sigma','-',
-     .              klev, znivsig, nvert)
+         CALL histvert(nid_day, "presnivs", "Vertical levels", "mb",
+     .                 klev, presnivs, nvert)
+c        call histvert(nid_day, 'sig_s', 'Niveaux sigma','-',
+c    .              klev, znivsig, nvert)
 c
          zsto = dtime
          zout = dtime * FLOAT(ecrit_day)
+C Essai writephys
+c        nom_fichier = 'histday1'
+c        call writephy_ini(fid_day,nom_fichier,klon,iim,jjmp1,klev,
+c    .                     rlon,rlat, presnivs,
+c    .                     zjulian, dtime)
+c        call writephy_def(prof2d_on, fid_day, "once", zsto, zout, 0)
+c        call writephy_def(prof3d_on, fid_day, "once", zsto, zout,
+c    .                                                         klev)
+c        call writephy_def(prof2d_av, fid_day, "ave(X)", zsto, zout, 0) 
+c        call writephy_def(prof3d_av, fid_day, "ave(X)", zsto, zout, 
+c    .                                                         klev)
+ 
 c
          CALL histdef(nid_day, "phis", "Surface geop. height", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "once", zsto,zout)
 c
          CALL histdef(nid_day, "aire", "Grid area", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "once", zsto,zout)
 c
@@ -694,85 +812,152 @@
 c
          CALL histdef(nid_day, "tsol", "Surface Temperature", "K",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "tter", "Surface Temperature", "K",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "tlic", "Surface Temperature", "K",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "toce", "Surface Temperature", "K",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "tsic", "Surface Temperature", "K",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "psol", "Surface Pressure", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "rain", "Precipitation", "mm/day",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "snow", "Snow fall", "mm/day",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "snow_cov", "Snow cover", "mm",
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "evap", "Evaporation", "mm/day",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "tops", "Solar rad. at TOA", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "topl", "IR rad. at TOA", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "sols", "Solar rad. at surf.", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "soll", "IR rad. at surface", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+         CALL histdef(nid_day, "solldown", "Down. IR rad. at surface", 
+     .                "W/m2", iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "bils", "Surf. total heat flux", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "sens", "Sensible heat flux", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "fder", "Heat flux derivation", "W/m2",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "frtu", "Zonal wind stress", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "frtv", "Meridional wind stress", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
-     .                "ave(X)", zsto,zout)
-c
-         CALL histdef(nid_day, "ruis", "Runoff", "mm/day",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
-     .                "ave(X)", zsto,zout)
-c
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
+     .                "ave(X)", zsto,zout)
+c
+C §§§ PB flux pour chauqe sous surface
+C
+         DO nsrf = 1, nbsrf
+C
+           call histdef(nid_day, "pourc_"//clnsurf(nsrf), 
+     $         "Fraction"//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+C
+           call histdef(nid_day, "tsol_"//clnsurf(nsrf), 
+     $         "Fraction"//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+C
+           call histdef(nid_day, "sens_"//clnsurf(nsrf), 
+     $         "Sensible heat flux "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+c
+           call histdef(nid_day, "lat_"//clnsurf(nsrf), 
+     $         "Latent heat flux "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+C
+           call histdef(nid_day, "taux_"//clnsurf(nsrf), 
+     $         "Zonal wind stress"//clnsurf(nsrf),"Pa",
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+
+           call histdef(nid_day, "tauy_"//clnsurf(nsrf), 
+     $         "Meridional xind stress "//clnsurf(nsrf), "Pa",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+C
+           call histdef(nid_day, "albe_"//clnsurf(nsrf), 
+     $         "Albedo surf. "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+C
+           call histdef(nid_day, "rugs_"//clnsurf(nsrf), 
+     $         "Latent heat flux "//clnsurf(nsrf), "W/m2",  
+     $         iim,jjmp1,nhori, 1,1,1, -99, 32,
+     $         "ave(X)", zsto,zout)
+
+C§§§
+         END DO 
+           
          CALL histdef(nid_day, "sicf", "Sea-ice fraction", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "cldl", "Low-level cloudiness", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "cldm", "Mid-level cloudiness", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "cldh", "High-level cloudiness", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "cldt", "Total cloudiness", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
          CALL histdef(nid_day, "cldq", "Cloud liquid water path", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32, 
+     .                iim,jjmp1,nhori, 1,1,1, -99, 32, 
      .                "ave(X)", zsto,zout)
 c
